
/******************************************************************************
 *
 * � Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/

#ifndef PNLLMCLI_H_
#define PNLLMCLI_H_

#include "../crypto/simplexml.h"

#define PN_ERROR_VM_POWERING_UP 42001
#define PN_ERROR_VM_OS_STARTING 42002
#define PN_ERROR_BROKER_BUSY 42005

#define Q_SECURE_TICKET_FILE "/tmp/qrdesktop_tix.bin"

extern "C"
{
int sweb(char* url, char* data, int datalength, char* outputbuffer, int outputbuffersize, int d);
int web(char* url, char* data, int datalength, char* outputbuffer, int outputbuffersize, int d);
}

int Authenticate(char* server, char* username, char* password, char* domain, char *tgt, bool nat, SimpleString& cookie);
int GetApplicationList(char* server, char* cookie, SimpleString& res, int type = 0); //0:all, 1:apps, 2:desktops
int GetServerList(char* server, char* cookie, SimpleString& res);
int GetLaunchInfo(char* server, char* cookie, char* applicationname, SimpleString& res);
int GetLeastBusyServer(char* server, char* cookie, SimpleString& res);

int ChangePassword(char *server, char *username, char *domain, char *oldPassword,
                   char *newPassword, char *cookie, SimpleString & res);

#endif //PNLLMCLI_H_
