
/******************************************************************************
 *
 * � Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/

//
//  AppPortal_AppDelegate.h
//  Provision AppPortal
//
//  Created by smalti on 4/1/09.
//  Copyright __MyCompanyName__ 2009 . All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "ManageConnectionAssist.h"
#import "PassManageTabAssist.h"
#import "Connection.h"
#import "PntscTask.h"

@interface AppPortal_AppDelegate : NSObject 
{
    IBOutlet NSWindow *window;
	
	IBOutlet NSPanel *notImplementedPanel;
	
	IBOutlet NSButton *btnChangeLocation;
	IBOutlet NSButton *btnLogonAsDifUser;
	IBOutlet NSButton *btnRefresh;
	
	IBOutlet NSPanel *changePassPanel;
	IBOutlet NSTextField *usrName;
	IBOutlet NSSecureTextField *domain;
	IBOutlet NSTextField *oldPass;
	IBOutlet NSTextField *newPass;
	IBOutlet NSTextField *confirmPass;
	IBOutlet NSPanel *enterCorrectvalueDialog;
	IBOutlet NSTextField *meaningMessage;
	
	IBOutlet NSPanel *logonAsDifUserPanel;
	IBOutlet NSTextField *usernameField;
	IBOutlet NSSecureTextField *passwordField;
	IBOutlet NSTextField *domainField;
	
	IBOutlet NSPanel *changeLocationPanel;
    IBOutlet NSPanel *viewShortcutsPanel;
	
	IBOutlet NSWindow *deskIntegrationWindow;
	
	IBOutlet NSTableView *farmList;
	IBOutlet NSTableView *appList;
    IBOutlet NSTableView *appListDI;
	
	IBOutlet NSArrayController *connectionArray;
	IBOutlet NSArrayController *locationArray;
	IBOutlet NSArrayController *launchedAppArray;
	
	IBOutlet ManageConnectionAssist *manageConnectionWindow;
	
	IBOutlet NSPanel *errorLaunchingPanel;
	IBOutlet NSTextField *errorMessage;
	IBOutlet NSPanel *succeededPanel;

    NSManagedObjectModel *managedObjectModel;
    NSManagedObjectContext *managedObjectContext;
	
	NSMenu *menu;
    NSMutableArray *farmSubmenuArr;
	
@private
	NSStatusItem *m_statusItem;
    NSMutableDictionary *farmsConnected;
    BOOL openFileStart;
    BOOL autolaunchConnectionsStart;
}

- (NSManagedObjectModel *)managedObjectModel;
- (NSManagedObjectContext *)managedObjectContext;


- (IBAction)saveAction:sender;
- (IBAction)manageConnection:(id)sender;
- (IBAction)closeApp:(id)sender;
- (IBAction)doConnectFarm:(id)sender;
- (IBAction)doConnectApp:(id)sender;
- (IBAction)doChangePass:(id)sender;
- (IBAction)doRefresh:(id)sender;
- (IBAction)doOkChangePass:(id)sender;
- (IBAction)doCancelChangePass:(id)sender;
- (IBAction)doOkConfirmCorrectDialog:(id)sender;
- (IBAction)doLogonAsDifUser:(id)sender;
- (IBAction)doChangeLocation:(id)sender;
- (IBAction)doConnectFromChangeLoc:(id)sender;
- (IBAction)doCancelChangeLocation:(id)sender;
- (IBAction)doViewShortcuts:(id)sender;
- (IBAction)doCloseViewShortcuts:(id)sender;

- (IBAction)doShowDeskIntegrationWindow:(id)sender;
- (IBAction)doCloseDeskIntegrationWindow:(id)sender;
- (IBAction)doDisconnectFarm:(id)sender;

- (IBAction)doCloseErrMessagePanel:(id)sender;
- (IBAction)doCloseSucceededMessagePanel:(id)sender;

- (void)showErrorLaunchingPanel;
- (void)showSucceededPanel;

- (BOOL)isValidTextField:(NSTextField *)textfield;

- (int)doGetAppList;
- (int)changePassword;
- (void)autolaunchConnections;

@end
