
/******************************************************************************
 *
 * � Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/

#import "AutoLaunchTabAssist.h"

@implementation AutoLaunchTabAssist

static id sharedInstance = nil;


#pragma mark -
#pragma mark Initialization

+ (id)sharedInstance {
	if (sharedInstance == nil)
		sharedInstance = [[self alloc] init];
	return sharedInstance;
}

-(id)init {
	if(sharedInstance) {
		[NSException raise:NSInternalInconsistencyException
					format:@"[%@] cannot be called; use +[%@ %@] instead",
		 NSStringFromClass([self class]), 
		 NSStringFromClass([self class]),
		 NSStringFromSelector(@selector(sharedInstance))];							 
	}	
	else
		sharedInstance = [super init];
	return sharedInstance;
}

- (void)dealloc {
	[super dealloc];
}


#pragma mark -
#pragma mark IBActions

- (IBAction)doAddApp:(id)sender {
	if([self isValidTextField:appNameCmbBox])
	{
		AppList *appItem = [[AppList alloc] init];
		[appItem setValue:[appNameCmbBox stringValue] forKey:@"appName"];
		[appArray addObject:appItem];
		[appItem release];
	}
	else
		return;
}

- (IBAction)doGetAppsList:(id)sender {
    
}

- (IBAction)doMoveAppDown:(id)sender {
	int selIndex = [appArray selectionIndex];
	if(selIndex < 0 || selIndex >= [[appArray arrangedObjects] count] - 1)
		return;
	AppList *appToMove = [[AppList alloc] initWithAppList:[[appArray selectedObjects] objectAtIndex:0]];
	int indexToInsert = selIndex + 1;
	[appArray setSelectionIndex:indexToInsert];
	AppList *appWhereMove = [[AppList alloc] initWithAppList:[[appArray selectedObjects] objectAtIndex:0]];
	[appArray removeObjectAtArrangedObjectIndex:indexToInsert];
	[appArray removeObjectAtArrangedObjectIndex:selIndex];
	[appArray insertObject:appWhereMove atArrangedObjectIndex:selIndex];
    [appArray insertObject:appToMove atArrangedObjectIndex:indexToInsert];
	[appArray setSelectionIndex:indexToInsert];
	[appToMove release];
	[appWhereMove release];
	[appsTable reloadData];
}

- (IBAction)doMoveAppUp:(id)sender {
	int selIndex = [appArray selectionIndex];
	if(selIndex <= 0)
		return;
	AppList *appToMove = [[AppList alloc] initWithAppList:[[appArray selectedObjects] objectAtIndex:0]];
	int indexToInsert = selIndex - 1;
	[appArray setSelectionIndex:indexToInsert];
	AppList *appWhereMove = [[AppList alloc] initWithAppList:[[appArray selectedObjects] objectAtIndex:0]];
	[appArray removeObjectAtArrangedObjectIndex:selIndex];
	[appArray removeObjectAtArrangedObjectIndex:indexToInsert];
    [appArray insertObject:appToMove atArrangedObjectIndex:indexToInsert];
	[appArray insertObject:appWhereMove atArrangedObjectIndex:selIndex];
	[appArray setSelectionIndex:indexToInsert];
	[appToMove release];
	[appWhereMove release];
	[appsTable reloadData];
}


- (void)setDefaultTabState {
}

- (BOOL)isValidTextField:(NSTextField *)textfield {
	NSString * typedText = [NSString stringWithString:[textfield stringValue]];
	return(![typedText isEqual:@""]);
}

- (BOOL)isDataCorrect {
//	if([self isValidTextField:appName])
		return YES;
//	return NO;
}

- (void)rDParam:(NSMutableArray *)input {
}

@end
