
/******************************************************************************
 *
 * � Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/

#import <Cocoa/Cocoa.h>

#import "AssistObserver.h"
#import "PntscTask.h"

#import "Broker.h"
#import "Location.h"
#import "Connection.h"
#import "Credentials.h"
#import "CredentialsTabAssist.h"
#import "PartialFormatter.h"

#define ConnectivityTabAssistIndex 2

@interface ConnectivityTabAssist : NSObject <AssistObserver>/* Specify a superclass (eg: NSObject or NSView) */ {
    IBOutlet NSTableView *brokersTable;
    IBOutlet NSButton *btnAddBroker;
    IBOutlet NSButton *btnDeleteBroker;
    IBOutlet NSButton *btnRenameLocation;
    IBOutlet NSButton *btnTestConnnection;
    IBOutlet NSPopUpButton *locationList;
    IBOutlet NSTextField *port;
    IBOutlet NSComboBox *protocolList;
	
	IBOutlet NSPanel *panelAddBroker;
	IBOutlet NSTextField *brokerAddressToAdd;
	IBOutlet NSPanel *confirmDialog;
	
	IBOutlet NSPanel *panelRenameLocation;
	IBOutlet NSTextField *locationName;
	
	IBOutlet NSPanel *panelTestConnection;
	IBOutlet NSTextField *testConCredFarmName;
	IBOutlet NSTextField *username;
	IBOutlet NSSecureTextField *password;
	IBOutlet NSTextField *domain;
	IBOutlet NSButton *chkBtnSaveCredentials;
	
	IBOutlet NSPanel *testConnectionStatusPanel;
	IBOutlet NSTextField *testConnectionStatus;
	
	IBOutlet NSPanel *promptLocationPanel;
	
	IBOutlet NSPanel *manageWnd;
	
	IBOutlet NSArrayController *brokerArray;
	IBOutlet NSArrayController *locationArray;
	IBOutlet NSArrayController *connectionArray;
	

	id <AssistObserver> m_assistObserver;
}

+ (id)sharedInstance;

- (void)setDefaultTabState;
- (BOOL)isDataCorrect;
- (void)rDParam:(NSMutableArray *)input;

- (void)initGUI;
- (BOOL)isValidTextField:(NSTextField *)textfield;

- (int)testConnection;
- (NSString *)composeBrokersString;

- (IBAction)setLocationAsDefault:(id)sender;
- (IBAction)doAddBroker:(id)sender;
- (IBAction)doCancelAddBroker:(id)sender;
- (IBAction)okAddBroker:(id)sender;
- (IBAction)okConfirmDialog:(id)sender;

- (IBAction)doCancelRenameLocation:(id)sender;
- (IBAction)okRenameLocation:(id)sender;

- (IBAction)doRenamelocation:(id)sender;
- (IBAction)doTestConnect:(id)sender;
- (IBAction)doCancelTestConnect:(id)sender;
- (IBAction)okTestConnect:(id)sender;
- (IBAction)okTestConnectStatusPanel:(id)sender;

- (IBAction)doMoveBrokerEntryDown:(id)sender;
- (IBAction)doMoveBrokerEntryUp:(id)sender;

@end
