
/******************************************************************************
 *
 * � Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/

//
//  Credentials.m
//  Provision AppPortal
//
//  Created by smalti on 4/10/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "Credentials.h"


@implementation Credentials

#pragma mark -
#pragma mark Initialization

- (id)init {
	if(self = [super init])
	{
		username = [[NSString alloc] initWithString:@""];
		password = [[NSString alloc] initWithString:@""];
		domain = [[NSString alloc] initWithString:@""];
		doUseCached = NO;
		doSave = NO;
	}
	return self;
}

- (id)initWithCredentials:(const Credentials *)input {
	if(self = [super init])
	{
		[self setUsername:[input username]];
		[self setPassword:[input password]];
		[self setDomain:[input domain]];
		[self setDoUseCached:[input doUseCached]];
		[self setDoSave:[input doSave]];
	}
	return self;
}

- (void)dealloc {
	[username release];
	[password release];
	[domain release];
	[super dealloc];
}


#pragma mark -
#pragma mark Setters

- (void)setUsername:(NSString *)input {
	[username autorelease];
	username = [input retain];
}

- (void)setPassword:(NSString *)input {
	[password autorelease];
	password = [input retain];
}

- (void)setDomain:(NSString *)input {
	[domain autorelease];
	domain = [input retain];
}

- (void) setDoUseCached:(BOOL)input {
	doUseCached = input;
}

- (void) setDoSave:(BOOL)input {
	doSave = input;
}

#pragma mark -
#pragma mark Getter

- (NSString *)username {
	return username;
}

- (NSString *)password {
	return password;
}

- (NSString *)domain {
	return domain;
}

- (BOOL)doUseCached {
	return doUseCached;
}

- (BOOL)doSave {
	return doSave;
}


#pragma mark -
#pragma mark Encode-Decode

- (void)encodeWithCoder:(NSCoder *)coder {
	if(doSave)
	{
		[coder encodeObject:username forKey:@"username"];
		[coder encodeObject:password forKey:@"password"];
		[coder encodeObject:domain forKey:@"domain"];
	}
	[coder encodeBool:doUseCached forKey:@"doUseCached"];
	[coder encodeBool:doSave forKey:@"doSave"];
}

- (id)initWithCoder:(NSCoder *)coder {
	if (self = [super init])
	{
		[self setUsername:[coder decodeObjectForKey:@"username"]];
		[self setPassword:[coder decodeObjectForKey:@"password"]];
		[self setDomain:[coder decodeObjectForKey:@"domain"]];
		doUseCached = [coder decodeBoolForKey:@"doUseCached"];
		doSave = [coder decodeBoolForKey:@"doSave"];
	}
	return self;
}


@end
