
/******************************************************************************
 *
 * � Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/

//
//  DesktopIntegration.m
//  Provision AppPortal
//
//  Created by smalti on 4/10/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "DesktopIntegration.h"


@implementation DesktopIntegration

#pragma mark -
#pragma mark Initialization

- (id)init {
	if(self = [super init])
	{
		doCreateInApps = NO;
	}
	return self;
}

- (id)initWithDesktopIntegration:(const DesktopIntegration *)input {
	if(self = [super init])
	{
		[self setDoCreateInApps:[input doCreateInApps]];
	}
	return self;	
}

- (void)dealloc {
	[super dealloc];
}

#pragma mark -
#pragma mark Setters

- (void)setDoCreateInApps:(BOOL)input {
	doCreateInApps = input;
}

#pragma mark -
#pragma mark Getters

- (BOOL)doCreateInApps {
	return doCreateInApps;
}

#pragma mark -
#pragma mark Encode-Decode

- (void)encodeWithCoder:(NSCoder *)coder {
	[coder encodeBool:doCreateInApps forKey:@"doCreateInApps"];
}

- (id)initWithCoder:(NSCoder *)coder{
	if(self = [super init])
	{
	    [self setDoCreateInApps:[coder decodeBoolForKey:@"doCreateInApps"]];
	}
	return self;
}

@end
