
/******************************************************************************
 *
 * � Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/

//
//  Display.m
//  Provision AppPortal
//
//  Created by smalti on 4/10/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "Display.h"


@implementation Display

#pragma mark -
#pragma mark Initialization

- (id)init {
	if(self = [super init])
	{
		color = [[NSString alloc] initWithString:@"256 Colors"];
		resolution = [[NSString alloc] initWithString:@"640 by 480 pixels"];
		
		height = [[NSString alloc] initWithString:@""];
		width = [[NSString alloc] initWithString:@""];
	}
	return self;
}

- (id)initWithDisplay:(Display *)input {
	if(self = [super init])
	{
		[self setColor:[input color]];
		[self setResolution:[input resolution]];
		[self setHeight:[input height]];
		[self setWidth:[input width]];
	}
	return self;
}

- (void)dealloc {
	[color release];
	[resolution release];
	
	[height release];
	[width release];
	[super dealloc];
}

#pragma mark -
#pragma mark Setters

- (void)setColor:(NSString *)input {
	[color autorelease];
	color = [input retain];
}

- (void)setResolution:(NSString *)input {
	[resolution autorelease];
	resolution = [input retain];
}

- (void)setHeight:(NSString *)input {
	[height autorelease];
	if(input == nil)
		height = [[NSString alloc] initWithString:@""];
	else
		height = [input retain];
}

- (void)setWidth:(NSString *)input {
	[width autorelease];
	if(input == nil)
		width = [[NSString alloc] initWithString:@""];
	else
		width = [input retain];
}

#pragma mark -
#pragma mark Getters

- (NSString *)color {
	return color;
}

- (NSString *)resolution {
	return resolution;
}

- (NSString *)height {
	return height;
}

- (NSString *)width {
	return width;
}

#pragma mark -
#pragma mark Encode-Decode

- (void)encodeWithCoder:(NSCoder *)coder {
	[coder encodeObject:color forKey:@"color"];
	[coder encodeObject:resolution forKey:@"resolution"];
	
	if([resolution isEqualToString:@"Custom"])
	{
		[coder encodeObject:height forKey:@"height"];
		[coder encodeObject:width forKey:@"width"];
	}
}

- (id)initWithCoder:(NSCoder *)coder {
	if(self = [super init])
	{
		[self setColor:[coder decodeObjectForKey:@"color"]];
		[self setResolution:[coder decodeObjectForKey:@"resolution"]];
		
		[self setHeight:[coder decodeObjectForKey:@"height"]];
		[self setWidth:[coder decodeObjectForKey:@"width"]];
	}
	return self;
}

@end
