
/******************************************************************************
 *
 * � Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/

//
//  Location.h
//  Provision AppPortal
//
//  Created by smalti on 4/10/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Broker.h>

@interface Location : NSObject <NSCoding> {

@private
	NSString *name;
	NSString *protocol;
	NSString *port;
	NSString *proxyServer;
	NSString *exclusiveServers;
	NSString *sslGateway;
	BOOL doUseAsDefault;
	BOOL doUseNatSupport;
	BOOL doUseSsl;
	BOOL doUseProxy;
	
	NSMutableArray *brokers;
}

- (id)init;
- (id)initWithLocation:(Location *)input;

- (void)setName:(NSString *)input;
- (void)setProtocol:(NSString *)input;
- (void)setPort:(NSString *)input;
- (void)setProxyServer:(NSString *)input;
- (void)setExclusiveServers:(NSString *)input;
- (void)setSslGateWay:(NSString *)input;
- (void)setDoUseAsDefault:(BOOL)input;
- (void)setDoUseNatSupport:(BOOL)input;
- (void)setDoUseSsl:(BOOL)input;
- (void)setDoUseProxy:(BOOL)input;
- (void)setBrokers:(NSMutableArray *)input;

- (NSString *)name;
- (NSString *)protocol;
- (NSString *)port;
- (NSString *)proxyServer;
- (NSString *)exclusiveServers;
- (NSString *)sslGateway;
- (BOOL)doUseAsDefault;
- (BOOL)doUseNatSupport;
- (BOOL)doUseSsl;
- (BOOL)doUseProxy;
- (NSMutableArray *)brokers;

- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;

@end
