
/******************************************************************************
 *
 * � Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/

#import <Cocoa/Cocoa.h>

#import "AssistObserver.h"
#import "PntscTask.h"
#import "Connection.h"
#import "AppList.h"

@interface ManageConnectionAssist : NSObject/* Specify a superclass (eg: NSObject or NSView) */ {
    IBOutlet NSButton *btnFinish;
    IBOutlet NSButton *btnNext;
    IBOutlet NSButton *btnPrev;
	IBOutlet NSButton *btnOk;
    IBOutlet NSButton *btnCancel;
    IBOutlet NSPanel *window;
	IBOutlet NSTabView *tabView;
	IBOutlet NSTextField *farmName;
	IBOutlet NSMatrix *stateMatrix;
	IBOutlet NSButtonCell *rbtnCreateNewFarm;
    IBOutlet NSButtonCell *rbtnModifyFarm;
	IBOutlet NSPanel *confirmCancelPanel;
		
	IBOutlet NSComboBox *appListCmbBox;
	
	IBOutlet NSPanel *credPanel;
	IBOutlet NSTextField *usernameField;
	IBOutlet NSSecureTextField *passwordField;
	IBOutlet NSTextField *domainField;
	
	IBOutlet NSPanel *errorLaunchingPanel;
	IBOutlet NSTextField *errorMessage;
	
	IBOutlet NSArrayController *connectionArray;
	IBOutlet NSArrayController *locationArray;
	IBOutlet NSArrayController *brokerArray;
	
	IBOutlet NSArrayController *launchedAppArray;
	
	NSMutableArray *m_connections;
	NSMutableArray *m_tabList;
	
	IBOutlet NSPanel *deskIntegrationPanel;
	IBOutlet NSWindow *mainWnd;
	
	IBOutlet NSPanel *fillFieldMesPanel;

@private
	Connection *m_currentConnectionItem;
	
	id <AssistObserver> m_assistsObserver;
	NSMutableArray *m_assistsArray;
	
	id m_tabAssist;

	unsigned int m_currentTabIndex;
	BOOL m_doCancel;
}

+ (id)sharedInstance;

- (void)initTabAssistsArray;

- (IBAction)doCancel:(id)sender;
- (IBAction)doOk:(id)sender;
- (IBAction)doFinish:(id)sender;
- (IBAction)goNext:(id)sender;
- (IBAction)goPrev:(id)sender;
- (IBAction)showModal:(id)ownerWnd sender:(id)sender;
- (IBAction)setModifyMode:(id)sender;
- (IBAction)setCreateMode:(id)sender;
- (IBAction)doConfirmCancel:(id)sender;
- (IBAction)doDeclineCancel:(id)sender;
- (IBAction)doGetAppList:(id)sender;
- (IBAction)doOkFillFieldMessage:(id)sender;

- (int)getApplicationsList;
- (int)getAppListWithArgs:(NSArray *)input;
- (void)launchApp;
- (int)launcAppWithName:(NSString *)input;

- (BOOL)createChangePassRequest:(NSMutableArray *)input;
- (void)createConnectArgsRequest:(NSMutableArray *)input;

// tab buttons actions
- (IBAction)goToTab0:(id)sender;
- (IBAction)goToTab1:(id)sender;
- (IBAction)goToTab2:(id)sender;
- (IBAction)goToTab3:(id)sender;
- (IBAction)goToTab4:(id)sender;
- (IBAction)goToTab5:(id)sender;
- (IBAction)goToTab6:(id)sender;
- (IBAction)goToTab7:(id)sender;
- (IBAction)goToTab8:(id)sender;
- (IBAction)goToTab9:(id)sender;
- (IBAction)goToTab10:(id)sender;

- (void)setCurrentMode;
- (void)closeWnd:(NSWindow *) wndClose;
- (void)closeSheet:(NSWindow *) wndClose;
- (void)setInitialManageFarmState;
- (void)clearTabs;
- (void)initTabs;
- (void)createNewConnection;

- (NSMutableArray *)connections;
- (void)setConnections:(NSArray *)newConnections;
- (NSString *)pathForDataFile;
- (void)saveDataToDisk;
- (void)loadDataFromDisk;

- (IBAction)createXWnd:(id)sender;

@end
