
/******************************************************************************
 *
 * � Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/

#import <Cocoa/Cocoa.h>

#import "AssistObserver.h"

#import "ConnectionPerformance.h"

#define UserExpTabAssistIndex 7

#define PERF_DISABLE_WALLPAPER	0x00000001
#define PERF_DISABLE_FULLWINDOWDRAG	0x00000002
#define PERF_DISABLE_MENUANIMATIONS	0x00000004
#define PERF_DISABLE_THEMING	0x00000008

@interface UserExpTabAssist : NSObject <AssistObserver>/* Specify a superclass (eg: NSObject or NSView) */ {
    IBOutlet NSButton *chkBtnAnimation;
    IBOutlet NSButton *chkBtnBitmapCaching;
    IBOutlet NSButton *chkBtnDesktopBackground;
    IBOutlet NSButton *chkBtnRecconect;
    IBOutlet NSButton *chkBtnThemes;
    IBOutlet NSButton *chkButtonShowContent;
    IBOutlet NSComboBox *connectionSpeed;
	
	IBOutlet NSArrayController *connectionArray;

@private
	NSMutableDictionary *modemsDict;
}

+ (id)sharedInstance;

- (void)setDefaultTabState;
- (BOOL)isDataCorrect;
- (void)rDParam:(NSMutableArray *)input;

- (IBAction)doSelectCustomSpeed:(id)sender;
- (IBAction)doCheckUserExpOption:(id)sender;
@end
